Subject: Re: [PATCH net-next v2] net: macb: set default_an_inband to true for SGMII

From: "Russell King (Oracle)" <[email-masked]>
Date: Sat, 14 Mar 2026 09:06:08 +0000

On Fri, Mar 13, 2026 at 07:06:31PM -0700, Jakub Kicinski wrote:
> On Fri, 13 Mar 2026 07:21:39 -0700 Charles Perry wrote:
> > Most platforms using GEM in SGMII mode use in-band autonegotiation
> > because it is on by default in GEM's 1G PCS and is always on since
> > commit e276e5e40e92 ("net: macb: Disable PCS auto-negotiation for SGMII
> > fixed-link mode"). Leave it on if possible using the "default_an_inband"
> > flag of "struct phylink_config" so that platforms that lack in-band
> > autonegotiation configurability at the PHY do not break with commit
> > 1338cfef1ff1 ("net: macb: fix SGMII with inband aneg disabled") which
> > will turn off in-band autoneg for non hot pluggable PHYs.
> > 
> > Once the majority of the PHY drivers that support SGMII have the
> > ->config_inband() callback, this commit could be reverted so that non  
> > hot pluggable PHY use outband negotiation with macb, like its the case
> > for other MACs.
> 
> I'm assuming this needs a respin now to account for the erronously
> merged patch?

It can be merged as well as the vitesse patch.

The problem with the vitesse patch is it _would_ break for MACs that
use phylink and always enable SGMII inband against phylink's
instruction as the vitesse PHY comes up with SGMII inband enabled.
Do we know of any MACs that are like that... well yes. There's at
least one, the thorn of a driver, the poor implementation, known as
stmmac. However, that wasn't the only one - the patch which caused
this regression shows that macb also ignored phylink's wishes.

Are there others? We don't know. This makes the vitesse patch
potentially unsafe and potentially being reverted if problems are
found during 7.1-rc.

So, I think having both patches in gives to best approach for now -
at least if the vitesse patch gets reverted, macb won't regress.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!